/*****************************  SuchBaumTest.java  ****************************/
import AlgoTools.IO;

/** Testet den SuchBaum mit Character-Objekten. Dazu wird ein Objekt der
 *  Klasse CharacterCompare erzeugt als Instanz des Interface Compare.
 */

public class SuchBaumTest {

    public static void main(String[] argv) {

        SuchBaum s = new SuchBaum(new CharacterCompare());

        char[] eingabe = IO.readChars("Bitte Zeichen fuer insert: ");

        for (int i=0; i<eingabe.length; i++)   // Elemente in SuchBaum einfuegen
            if (s.insert(new Character(eingabe[i])))
                IO.println(eingabe[i] + " eingefuegt");
            else
                IO.println(eingabe[i] + " konnte nicht eingefuegt werden");

        IO.print("Inorder: ");
        Traverse.inorder(s);                   // Inorder-Traversierung
        IO.println();

        eingabe = IO.readChars("Bitte Zeichen fuer lookup: ");

        for (int i=0; i<eingabe.length; i++) { // Elemente im SuchBaum suchen
            Object o = s.lookup(new Character(eingabe[i]));
            if(o == null)
                IO.println(eingabe[i] + " konnte nicht gefunden werden");
            else
                IO.println(((Character)o).charValue() + " gefunden");
        }

        eingabe = IO.readChars("Bitte Zeichen fuer delete: ");

        for (int i=0; i<eingabe.length; i++) { // Elemente im SuchBaum loeschen
            if (s.delete(new Character(eingabe[i])))
                IO.println(eingabe[i] + " geloescht");
            else
                IO.println(eingabe[i] + " konnte nicht geloescht werden");

            IO.print("Inorder: ");
            Traverse.inorder(s);               // Inorder-Traversierung
            IO.println();
}   }   }
